#
# spec file for package ghc-exceptions
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name exceptions
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.10.0
Release:        lp151.1.2
Summary:        Extensible optionally-pure exceptions
License:        BSD-3-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/2.cabal#/%{pkg_name}.cabal
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-transformers-compat-devel
BuildRequires:  ghc-transformers-devel
%if %{with tests}
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-test-framework-devel
BuildRequires:  ghc-test-framework-hunit-devel
BuildRequires:  ghc-test-framework-quickcheck2-devel
%endif

%description
Extensible optionally-pure exceptions.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc AUTHORS.markdown CHANGELOG.markdown README.markdown

%changelog
* Sat Oct 20 2018 Peter Simons <psimons@suse.com>
- Update Cabal build instructions to support ghc-8.6.1.
* Wed Jul 18 2018 psimons@suse.com
- Cosmetic: replace tabs with blanks, strip trailing white space,
  and update copyright headers with spec-cleaner.
* Fri Jul 13 2018 psimons@suse.com
- Update exceptions to version 0.10.0.
  0.10.0
  - -----
  * Fix a regression in 0.9.0 whereby the non-IO effects in `bracket`'s `use`
    action were not visible to the `release` action, and the non-IO effects in the
    `release` action were not visible after the `bracket` call.
  * The type of `generalBracket` was changed in order to restore those non-IO
    effects, so if you are a library author that provides a `MonadMask` instance,
    you will need to update your implementation of this method.
  * Add `MonadMask` instance for `MaybeT`
  * Add `onError` function whose action also runs on errors which are not
    exceptions, such as a `Nothing` or a `Left`.
  0.9.0
  - ----
  * Add `generalBracket` to the `MonadMask` typeclass, allowing more
    valid instances.
    Note that functions such as `bracket` and `finally` are now based off of
    `generalBracket`, so if you are a library author that provides a `MonadMask`
    instance, you will need to provide an implementation of this method.
  * Add `MonadMask` instances for `ExceptT` and `ErrorT`
* Wed May 16 2018 psimons@suse.com
- Prefer the new %%license attribute over %%doc.
- Update Cabal file to revision 5.
  * support GHC 8.4.x
  * support QuickCheck 2.11.x
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Mon Jun 19 2017 psimons@suse.com
- Update to version 0.8.3 revision 2.
* Thu Dec  8 2016 psimons@suse.com
- Update to version 0.8.3 revision 1 with cabal2obs.
* Fri Jul 22 2016 psimons@suse.com
- Update to version 0.8.3 revision 0 with cabal2obs.
* Tue Jul 19 2016 psimons@suse.com
- Update to version 0.8.2.1 revision 1 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.8.2.1 revision 0 with cabal2obs.
* Mon Jan 18 2016 mimi.vx@gmail.com
- update to  0.8.2.1
  * Support for throwing in the template-haskell Q monad
  * Support for transformers 0.5
* Tue Apr 21 2015 mimi.vx@gmail.com
- update to 0.8.0.2
  * Use `transformers-compat` to allow support for `ExceptT` even on older `transformers` versions.
  * `stm` support
* Wed Mar 11 2015 peter.trommler@ohm-hochschule.de
- remove unnecessary build requires
* Sun Feb  1 2015 mpluskal@suse.com
- Initial packaging (version 0.6.1)
